sub spamassassin {
  #Only run SA if mail is from a "remote" SMTP client, or QS_SPAMASSASSIN 
  #is defined via tcpserver...
  return if (defined($ENV{'RELAYCLIENT'}) && !defined($ENV{'QS_SPAMASSASSIN'}));
  #SpamAssassin client scanner
  my ($spamassassin_found,$spamassassin_status);
  my ($start_spamassassin_time)=[gettimeofday];
  my ($DD,$spamassassin_status,$stop_spamassassin_time,$spamassassin_time);
  my ($sa_status)=0;
  my ($sa_score)=0; my ($sa_max)=0;
  &debug("SA: run $spamc_binary $spamc_options < $scandir/$wmaildir/new/$file_id");
  open(SA,"$spamc_binary $spamc_options < $scandir/$wmaildir/new/$file_id|")||&tempfail("cannot run $spamc_binary  < $scandir/$wmaildir/new/$file_id - $!");
  open(SOUT,">$scandir/$wmaildir/new/$file_id.spamc")||&tempfail("cannot open for write $scandir/$wmaildir/new/$file_id.spamc - $!");
  while (<SA>) {
    if ($spamc_options =~ /\-c/) {
      ($sa_score,$sa_max)=split(/\//,$_,2);
      $sa_max=~s/\n//g;
    }
    #X-Spam-Status: No, hits=2.8 required=5.0
    if (/^X-Spam-Status: (Yes|No), hits=([0-9\.]+) required=([0-9\.]+)/) {
      $sa_status=1 if ($1 eq "Yes");
      $sa_score=$2;$sa_max=$3;
    }
    print SOUT;
  }
  close(SA);
  $spamassassin_status=($? >> 8);
  $sa_status=$spamassassin_status if ($spamc_options =~ /\-c/);
  close(SOUT);
  if ($spamc_options !~ /\-c/ && -s "$scandir/$wmaildir/new/$file_id.spamc" && $spamassassin_status == 0) {
    &debug("SA: overwriting $scandir/$wmaildir/new/$file_id with $scandir/$wmaildir/new/$file_id.spamc");
    rename ("$scandir/$wmaildir/new/$file_id.spamc","$scandir/$wmaildir/new/$file_id");
  } else {
    unlink("$scandir/$wmaildir/new/$file_id.spamc");
  }
  if ($sa_status == 0) {
    if ($sa_max == 0) {
      $tag_score .= "SA:?($sa_score/$sa_max):";
    } else {
      $tag_score .= "SA:0($sa_score/$sa_max):";
      $sa_comment = "No, hits=$sa_score required=$sa_max" if ($spamc_options =~ /\-c/);
    }
  } else {
    $tag_score .= "SA:1($sa_score/$sa_max):";
    $sa_comment = "Yes, hits=$sa_score required=$sa_max" if ($spamc_options =~ /\-c/);
    &debug("SA: yup, this smells like SPAM");
  }
  
  $stop_spamassassin_time=[gettimeofday];
  $spamassassin_time = tv_interval ($start_spamassassin_time, $stop_spamassassin_time);
  &debug("spamassassin: finished scan of dir \"$scandir/$file_id\" in $spamassassin_time secs");
}


