
sub check_and_grab_uuencoding {
  my ($begin,$perms,$uufile,$uuextension,$uulength,$uuencoded_attachments);
  if (/^(begin) ([0-9][0-9][0-9]) (.*)\n$/) {
    &debug("Ooohhhh, a uuencoded attachment!");
    $uuencoded_attachments++;
    $begin=$1;
    $perms=$2;
    $uufile=$3;
    push(@uufile_list, $uufile);
    $uufile=~s/[^0-9a-z\_\-\.]/_/gi;
    $uufile =~ /\.([^\.]+)$/;
    $uuextension=$1;
    #Ensure the file extension isn't too long either...
    $uuextension=substr($uuextension,0,20); 
    $uulength=length($uufile);
    #Ensure the filelength isn't too large!
    if ( $uulength > $MAX_FILE_LENGTH) {
      &debug("uudecode output: gah! filename is > $MAX_FILE_LENGTH (actually $uulength), chopping...");
      $uufile=substr($uufile,0,$MAX_FILE_LENGTH).".".$uuextension;
    }
    if (! -f "$scandir/$file_id/$file_id-$uuencoded_attachments-$uufile.uue") {
      open(UUIN,">$scandir/$file_id/$file_id-$uuencoded_attachments-$uufile.uue")||&tempfail("cannot open $scandir/$file_id/$file_id-$uuencoded_attachments-$uufile.uue - $!");
    } else {
      &tempfail("$scandir/$file_id/$file_id-$uuencoded_attachments-$uufile.uue already exists! - $!");
    }
    print UUIN "$begin 600 $uufile\n";
    print TMPFILE;
    while (<STDIN>) {
      print UUIN;
      print TMPFILE;
      if (/^end/) {
	close(UUIN)||&tempfail("cannot close $scandir/$file_id/$file_id-$uuencoded_attachments-$uufile - $!");
	#uudecode it - toss away the error code - who cares if it's broken...
	&debug("c_a_g_u: $uudecode_binary $uudecode_pipe $scandir/$file_id/$file_id-$uuencoded_attachments-$uufile.uue");
	open(UUOUT,"$uudecode_binary $uudecode_pipe $scandir/$file_id/$file_id-$uuencoded_attachments-$uufile.uue|");
	open(UUFILE,">$scandir/$file_id/$file_id-$uuencoded_attachments-$uufile");
	while (<UUOUT>) {
	  print UUFILE;
	}
	close UUOUT;
	close UUFILE;
	&debug("deleting uuencoded file as we have a decoded version of it now");
	unlink("$scandir/$file_id/$file_id-$uuencoded_attachments-$uufile.uue") if ($DEBUG < 100);
	last;
      }
    }
  }
}

