<!doctype html public "-//w3c//dtd html 4.0 transitional//en">
<html>
<head>
   <meta name="MSSmartTagsPreventParsing" content="TRUE" />
   <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
   <meta name="keywords" content="activex, av, avp, cai, clamscan, content scanner, e-mail, email, enterprise, filtering, f-prot, fsecure, inoculan, internet, intranet, java, javascript, linux, macafee, commandcom, misuse anti-virus, network, perl, qmail, qmail-queue qmail-scanner, scan, scan, scan4virus, scanning, scanning, script, security, SMTP, sophie, sophos, spam, spam assassin, spamassassin, trend, trophie, unix, virus, worms">
   <meta date="<?php echo   date ("l dS of F Y h:i:s A",filemtime($SCRIPT_FILENAME)); ?>">
   <title>Qmail-Scanner - An Content Scanner for Qmail</title>
</head>
<body bgcolor="#FFFFFF">
   <font size="-3"><b>Last Updated:</b> <?php echo   date ("l dS of F Y h:i:s A",filemtime($SCRIPT_FILENAME)). " GMT"; ?></font>

<div align="right"><A href="http://sourceforge.net"> <IMG src="http://sourceforge.net/sflogo.php?group_id=6116" width="88" height="31" border="0" alt="SourceForge Logo"></A></div>


<div align="left"><a href="http://qmail-scanner.sourceforge.net/" align="left">URL: http://qmail-scanner.sourceforge.net/</a></div>
<center>
<h1>
<a href="http://qmail-scanner.sourceforge.net/" align="center">Qmail-Scanner:
Content Scanner for Qmail</a></h1></center>

<P>

      <i><font size="2">Copyright 2000/2002 Jason Haar. This software is distributed
under the terms of the GNU General Public License. See <a href="COPYING">COPYING</a> for additional information.</font>
    </i>



<P>

<h2>Description</h2> <b>Qmail-Scanner</b>, (also known as scan4virus)
is an addon that enables a Qmail Email server to scan all gatewayed
Email for certain characteristics (i.e. a content scanner).  It is typically used for its
anti-virus protection functions, in which case it is used in
conjunction with commercial virus scanners. but also enables a site (at a server/site level) to
react to Email that contains specific strings
in particular headers, or particular attachment filenames or types
(e.g. *.VBS attachments). It also can be used as an archiving tool for
auditing or backup purposes.  Qmail-Scanner is integrated into the
mail server at a lower level than some other Unix-based virus
scanners, resulting in better performance. It is capable of scanning
not only locally sent/received Email, but also Email that crosses the
server in a relay capacity. 

<h2>
Features</h2>

<ul>
<li>
Uses any commercial Unix command-line virus scanner.</li>

<li>
Can call more than one virus scanner for each mail message</li>

<li>
Has its own internal scanner that can be used to
pick up viruses for which  commercial scanner updates are not yet available</li>

<li>
The internal scanner can also be used to block Email based on attachment types,
or Email with certain Email headers... Need to stop *.mp3 files or "<b>Subject:</b>
ILOVEYOU" Email getting onto and off your LAN - can do! :-)</li>
      <li>Can integrate with SpamAssassin to provide comprehensive anti-spam tagging for an entire site</li>
<li>
Auto-detects Email from "postmaster"-style and mailing-list
addresses - and doesn't send virus reports to them (i.e. attempts to act
more like a responsible net citizen)</li>

<li>
Each message is tagged via a new <b>Received:</b> header
with a virus report showing whether it is clean or not and virus scanner
version numbers/etc</li>

<li>
Messages with viruses are moved into a "maildir" mail folder
for later perusal by the appropriate staff</li>

<li>
Can optionally add a descriptive header: <b>X-Qmail-Scanner</b>
to every Email that passes through the system to allow users to see that
a scanner has run over their messages</li>

<li>
Messages caught by Qmail-Scanner generate an Email message (currently
	supports English, Italian, German, Spanish, Turkish,
	Lithuanian, French, Portuguese and Chinese messages) to a configurable combination of the sender, recipients and a "quarantine-admin" address explaining why their message was rejected
</Li>
<li>
Can archive all processed Email into an archive maildir.
Useful when debugging Email-based apps, for backup purposes and for audit
policy reasons. Currently the mail envelope headers (the "rcpt to:" and "mail from:" headers) are appended to the bottom of each message.</li>
<li>Can report via syslog or to a file, a one-line description of each processed message, giving information such as subject line, attachment filenames, sizes, etc.</li>
<li>
Redundant scanning. Not only does it unpack each message
before running the scanners over it, it can also scan the original Email
message as well as the unpacked messages (if you think a particular scanner
can do a better job than <i>Qmail-scanner</i>'s internal systems allow.)</li>
</ul>

<h2>
Download</h2>
The latest release is 1.13 <a href="http://prdownloads.sourceforge.net/qmail-scanner/qmail-scanner-1.13.tgz">(via http)</a>,
and is kindly housed by <a href="http://sourceforge.net/">SourceForge</a>. GnuPG signature of <a href="http://prdownloads.sourceforge.net/qmail-scanner/qmail-scanner-1.13.tgz.asc">qmail-scanner-1.13.tgz</a> is also available. Of course, you'll be needing my <a href="http://qmail-scanner.sourceforge.net/jhaar@users.sourceforge.net.gpg">GPG Public Key</a> to verify that.
<h2>
Requirements</h2>

<ul>
<li>
Qmail 1.03 (<font size="-2">there's a <a href="http://untroubled.org/qmail+patches/">patched src RPM</a> for Linux users available that contains the QMAILQUEUE patch amongst other things - just "rpm --rebuild" as root to build your own i386.rpm. NOTE: I cannot vouch for it - I do not use it. Please ensure you know how it works before installing Qmail-Scanner.</font>)</li>

<li>
<b>reformime</b> from <a href="http://download.sourceforge.net/courier/">Maildrop
1.3.8+</a></li>
 
<li>
Perl 5.005_03+</li>

<li>
Perl module <a href="http://search.cpan.org/search?module=Time::HiRes">Time::HiRes</a></li>
<li>
Perl module <a href="http://search.cpan.org/search?module=DB_File">DB_File</a> (most distributions come with it pre-installed, although the latest Perl  doesn't)</li>
      <li>Perl module <a href="http://search.cpan.org/search?module=Sys::Syslog">Sys::Syslog</a> (most distributions come with it pre-installed)</li>
<li><b>Barely Optional:</b> Mark Simpson's <a href="http://world.std.com/~damned/software.html">TNEF unpacker</a>. Can decode those annoying MS-TNEF MIME attachments that Microsoft mail servers just <em>love</em> to use. If you don't have this, there are several classes of Email that you basically won't be able to detect viruses in.</li>
</ul>

<h3>
Patches</h3>
Bruce Guenter's <a href="http://www.qmail.org/qmailqueue-patch">QMAILQUEUE</a>
patch is required to enable Qmail to call a different qmail-queue program
than the one compiled in by default. <i>Qmail-scanner</i>'s
<b>qmail-scanner-queue.pl</b>
perl script is used instead of Qmail's
<b>qmail-queue</b> binary. After
<b>qmail-scanner-queue.pl</b>
has run, it calls the original <b>qmail-queue</b> binary to resubmit the
message back into the system.
<ul>
<li>
<b>Note 1:</b> Bruce Guenter also provides a <a href="http://untroubled.org/qmail+patches/">patched qmail-1.03 RPM</a> for Linux systems that contains the above patch plus a bunch of other bits and pieces. Linux users may find it easier to use that. As mentioned above, please ensure you have Qmail working before installing Qmail-Scanner. On the Qmail-Scanner mailing-lists, we are seeing too many cases of users having "problems" - which end up being Qmail configuration/understanding issues...</li>
</ul>

<h3>
Supported Virus Scanners</h3>
The following virus scanners are known to work with qmail-scanner.
Other Unix-based scanners should be simple to add support for.
<ul>
<li>
<a href="http://www.antivirus.com/">Trend's Virus scanner</a></li>

<li>
<a href="http://www.sophos.com/">Sophos's "sweep" virus scanner</a></li>

<li>
<a href="http://www.hbedv.com/">H+BEDV's antivir scanner</a></li>

<li>
<a href="http://www.kaspersky.com/">Kaspersky's AVPLinux scanner</a></li>

<li>
<a href="http://www.nai.com/">MacAfee's (NAI's) virus scanner</a></li>
      <li><a href="http://www.commandcom.com">Command's virus scanner</a></li>
<li>
<a href="http://f-secure.com/">F-Secure Anti-Virus scanner</a></li>
      <li><a href="http://www.f-prot.com/f-prot/products/fplin.html">F-Prot Anti-Virus scanner</a></li>
<li>
<a href="http://www.cai.com/">InocuLAN Anti-Virus scanner</a></li>
      <li><a href="http://clamav.elektrapro.com/">Clam Antivius</a> - an Open Source antivirus scanner</li>
      <li><a href="http://www.rav.ro/">RAV Antivirus</a></li>
<li><a href="http://www.vanja.com/tools/">Sophie: Daemon front-end to Sophos Sweep</a> (see <a href="FAQ.php">FAQ</a> for details)</li>
<li><a href="http://www.vanja.com/tools/">Trophie: Daemon front-end to Trend iscan</a> (see <a href="FAQ.php">FAQ</a> for details)</li>
      <li><a href="http://spamassassin.org/">Spam Assassin Daemon</a> (see <a href="FAQ.php">FAQ</a> for details)</li>
</ul>

<h2>CHANGES</h2>
<P> There is a separate <a href="CHANGES">page</a> listing changes that have been made between releases </p>

<h2>
TODO</h2>
<p>       There is a separate <a href="TODO.php">TODO</a> page.</p>

<h2>
FAQ</h2>
<p>       There is a separate <a href="FAQ.php">FAQ</a> page.</p>

<h2>
Performance/Resource Usage</h2>

Adding content/virus scanning to an Email server <i>will</i>
considerably add to the resource usage of that server. As this
"wrapper" is written in perl instead of low-level C, quite a lot of
memory and file opens/stats occurs just to get it going. Adding to
this the actual scanners memory and CPU usage and it becomes quite
complicated (certainly the debugging info shows that the scanner
harness spends more time running the commercial scanners than it does
doing things itself [that is to be expected as they do quite a lot of
thinking...]).  <p>As a "rule of thumb" I'd suggest you look at how
many simultaneous SMTP sessions you are willing your box to have going
at any one point in time. Each SMTP session can invoke up to 'n'
different virus scanners (although they run one after the other - not
simultaneously) and I'd estimate that leads to around 5-6Mb of memory
usage per SMTP session.  Thus if your dedicated SMTP host has 256Mb
RAM + 256Mb swap - that should mean you can handle - well heaps ;-)
The scanners cause the CPU to be thrashed while they're running, so
I'm making sure for our site that our Qmail server will only accept up
to 30 incoming SMTP sessions at any one time - that way I know the box
will handle it. As this leads to an increased memory usage, don't
forget Qmail's memory limits  will need to be increased to deal with it (set
via ulimit or softlimit calls with Qmail system startup scripts).
<p>One thing you should test for is what happens if connectivity
between this server and another local SMTP server is down for any
length of time (due to failure/power outage). When the link is
restored, can your server handle the other trying to dump 1,000's of
Email msgs onto it at once? You need to use softlimit and tcpserver's
limit options to ensure your box doesn't get killed. Note that this
resource issue isn't caused by Qmail-Scanner.
The same thing will happen with a pure, untouched Qmail (or any other)
system - it will just happen sooner...
<p>After that scare-mongering I should say that I have tested
Qmail-Scanner under ridiculously low resource conditions - and it reacts as
it should - so at worst your system should start deferring Email. Thankfully
DJB's layering of programs is such that this is easy to accomplish :-)
<h2>
Installation</h2>

<ul>
<li>
Unpack <i>Qmail-Scanner</i> and run <b>./configure --help</b>.
This will show you what
<a href="configure-options.php">options</a>
are available to you.</li>

<li>
Run <b>./configure ...</b> [with your options], it will autodetect
what software is installed on your system, and will generate a script specific
to your system. If you don't see any errors reported, then the build is (probably) successful.</li>

<li>
Run <b>./configure</b> again, this time include "<i>--install</i>" along with the options you chose, this will do the same as the previous line, but will also create the directory structure
required, and install <b>qmail-scanner-queue.pl</b></li>

<li>
If you want to manually install it, see the <a href="manual-install.php">Manual
Installation</a> page.</li>
<li>
Before going any further, you can test the installation by running <b>./contrib/test_installation.sh</b>. This will send three Emails: one normal and two "infected" with the EICAR test virus - to the administrator Email address. Obviously <i>Qmail-Scanner</i> should catch them, quarantine them and send messages to the administrator stating that such messages had been caught. The EICAR is a test virus - not a real one - so don't get too concerned! :-) If you receive the original messages instead of "Virus found" messages, then something is wrong with your install.</li>

</ul>
At this stage  qmail-smtpd will need to be "told"  that Qmail knows to use <b>qmail-scanner-queue.pl</b>
    instead of <b>qmail-queue</b>. This is done via the tcpserver control files for smtp. Look to see where tcpserver for qmail-smtpd gets its rules from - it's the file after the "-x" option (well, that's the CDB version actually - find the text file yourself! ;-). Edit that file and tell qmail-smtpd which IP address ranges (corresponds to SMTP client IP addresses) you want Qmail-Scanner to be invoked on - typically all of them.<p>
	  <pre>
#/etc/tcpserver/smtp.rules
#
# No Qmail-Scanner at all for mail from 127.0.0.1
127.:allow,RELAYCLIENT="",RBLSMTPD="",QMAILQUEUE="/var/qmail/bin/qmail-queue"
# Use Qmail-Scanner without SpamAssassin on any mail from the local network
# [it triggers SpamAssassin via the presence of the RELAYCLIENT var]
10.:allow,RELAYCLIENT="",RBLSMTPD="",QMAILQUEUE="/var/qmail/bin/qmail-scanner-queue.pl"
#
# Use Qmail-Scanner with SpamAssassin on any mail from the rest of the world
:allow,QMAILQUEUE="/var/qmail/bin/qmail-scanner-queue.pl"
</pre></p>

<P>
The above example means from now on all SMTP mail will be scanned, but
with different characteristics. Mail from the LAN (10. network) will
be scanned by the supported virus scanners, whereas mail from the
Internet will be scanned for viruses AND tagged by SpamAssassin. This
finer control allows you a lot of versatility, e.g. virus scanning
only performed on mail coming from your Exchange server, and not from your Unix servers.

<P>

<table>
<tr>
<td BGCOLOR="#F5DEB3">You <em>must</em> increase the amount of memory your system allows qmail-smtpd
to run with, as it it now running the entire perl interpreter PLUS
virus scanners. Typical installs of Qmail have system rc/startup
scripts (e.g. <b>/etc/rc.d/init.d/qmail</b> or <b>/service/smtp/run</b>) that limit the amount of RAM qmail-smtpd can use via ulimit or
softlimit. You must increase that to around 5-6Mb. If you don't
qmail-smtpd will crash with a "qq" error on the receipt of the very
first message... The actual amount is dependent on the OS in question as well as the virus scanners being used, so be prepared to experiment a little. Whatever you do, <em>don't</em> just set it to something stupid like 100M "just to be sure". The whole point about limiting RAM usage is so that "unusal" mail messages (e.g. from spammers or hackers) can't cause your system to become unusable by making it run out of RAM.</td>
</tr>
</table>


<p>To scan all mail sent by local shell users, the <b>QMAILQUEUE</b>
will also need to be defined within <b>/etc/profile</b> or the like so
that when they send mail, it will be affected as well.
<table>
<tr>
<td BGCOLOR="#F5DEB3">Although as they are obviously Unix users,
you may want to save your system the effort and explicitly NOT do that!
	  :-)<p>Also, think twice before running Qmail-Scanner in front of any mailing-list servers. Do you really think it's a good idea to have 10,000 messages banging away at your antivirus system at the same time? Either put your mailing-list servers beyond the reach of your Qmail-Scanner servers, or put the mailing-list on the Qmail-Scanner servers themselves - that way each message is only scanned once and the load issues disappear.</p></td>
</tr>
</table>

<p>If "<i>$DEBUG=1</i>" (the default) is set within <b>qmail-queue-scanner.pl</b>, then every transaction
will be logged to
<b>/var/spool/qmailscan/qmail-queue.log</b> - so you'll
see how it goes. Regardless of debugging, errors (and attachment info if
enabled) should also be recorded in the qmail logs (probably via <i>syslog</i>)
- just look for entries containing the string "<b>X-Qmail-Scanner</b>".
<p>Any SMTP sessions that are dropped (due to network outages/etc)
may lead to files lying around in <b>/var/spool/qmailscan </b>. Running
<b>/var/qmail/bin/qmail-scanner-queue.pl -z</b> at least once daily will 
ensure such files are deleted when they're
over 30 hours old - make a cronjob to do that. Also realise that <b>/var/spool/qmailscan/qmail-queue.log</b> will grow without bounds. At some stage turn debugging off (<i>$DEBUG=0</i>) and delete the logfile. Personally, I like the logfile, so I run a cronjob that just does "mv -f qmail-queue.log  qmail-queue.log.1" at 3am every morning. That way logs don't grow without bound, but you still end up with the logs from the past two days. The file can be safely deleted at any time if it becomes a disk-hog, but unless "<i>$DEBUG=0</i>" is set, it'll just get re-created the next time a message comes through.
<P>

Qmail-Scanner contains an internal scanner which allows you to reject Email
based on attachment filenames and/or Email headers. Read the <a href="perlscanner.php">minimal  document</a> on it for details.

<P>
<h2>
Philosphy behind Quarantining...</h2>
When Qmail-Scanner decided to quarantine a message, it moves
it into a local  mail folder (maildir format) - by default
<b>/var/spool/qmailscan/quarantine/</b>.
This means the message can be read in its pure "adulterated" state (e.g. still containing viruses) by maildir
clients like <a href="http://www.mutt.org/">mutt</a> - or via IMAP (if
maildir format supported - you'll have to work that out for yourself).
At worse you can just read it with an editor - it's just a MIME file...
<p>If you want a good IMAP server that supports maildir natively
- try <a href="http://www.inter7.com/courierimap/">Courier-IMAP</a>.
<p>I made the decision to write it into maildir format for
performance and reliability reasons - and it expressly makes it difficult
for any Windows admin to click on it with their vulnerable Windows mailer
and read it :-) Qmail actually comes with a program called /var/qmail/bin/maildir2mbox
which can do just that... (you could run it from cron to automatically
suck all the new mail messages from <b>/var/spool/qmailscan/quarantine/new/</b>
into a mbox.)
<p>

      Also note that Qmail-Scanner <em>only</em> quarantines. It
      doesn't drop or "clean" messages. Cleaning a message is
      complicated and is becoming less of an issue. Personally I feel
      that if someone sends a virus-laden message through
      Qmail-Scanner, then it should be blocked - not cleaned. Why
      should Qmail-Scanner "fix" someone elses problem? People need to
      take responsibility for their own problems. They get an alert
      telling them they're infected, so they will need to disinfect
      their system before attempting to send mail through your site
      again. Virus scanners that "clean" just make these people think
      they don't have to worry about their problem - someone else is
      fixing it. </p>

<p>
Qmail-Scanner also doesn't distinguish between
      "blocking" attachments (via the perlscanner module) and
      viruses. i.e. if a zip file contains a MP3 file, and you are
      blocking MP3s - then the message will be quarantined. Some
      people think that Qmail-Scanner should only block files if they
      are "direct" attachments - not contained within archive
      attachments. Again, if you have a policy saying "no MP3" - then
      it should apply no matter how it's sent... </p>

<p>Finally, I am finding
      the majority of viruses are now trojans - which means that there
      is no actual human-generated message to allow through
      anyway. There is nothing more annoying than being behind some
      other vendors antivirus scanner when 1,000 copies of the latest
      virus comes through. Receiving 1,000 copies of a "cleaned"
      trojan is only maginally better than receiving the trojan! (in
      fact it's worse for Unix users like me! ;-) In fact, but the
      10'th copy, all the users receiving mail are now paranoid to
      open <em>any</em> mail as they don't feel secure about what's
      going on. The better response is that the ORIGINATOR receive
      1,000 alerts telling them they're infected - maybe they'll do
      something about it. 
</p>

<p>Also this event is logged in <b>/var/spool/qmailscan/quarantine.log</b>
in a tab-delimited format (for post-processing). A good script is needed
to convert this file into some nice graphs for management :-). See <a
								      href="http://www.mandranet.com/open-source/qss">QSS</a> for an example of one way of generating stats.

<P>
If Qmail-Scanner was configured with the "--log-details" option, then a 
one-line summary of every message processed is recorded either in mailstats.csv or via syslog. e.g:
<P>
<pre>
Jan 16 10:42:51 mailhost perlscanner: BadTrans 0.967762 xuy@213.3 remote@addr Franky_says_RELAX <> 1646 Wed,_16_Jan_2002_10:42:42_+1300 1011130969.31369-0.mailhost:117 1011130969.31369-1.mailhost:139  
Jan 16 10:42:52 mailhost perlscanner: Clear: 0.2322 jhaar@users.sourceforge.net jhaar@users.sourceforge.net Testing_testing <08008383883@mailhost> 2345 Wed,_16_Jan_2002_10:42:42_+1300 1011130969.31369-0.mailhost:117 1011130969.31369-1.mailhost:139 
</pre>

<h2>
Support</h2>
This software is released under the GPL as found in the <a href="COPYING">COPYING</a>
file enclosed.
<p>This package is housed on <a href="http://sourceforge.net/project/?group_id=6116">SourceForge</a>.
<p>
Any questions, suggestions, etc to the mailing-list set up to discuss this, subscribe via <a href="http://lists.sourceforge.net/mailman/listinfo/qmail-scanner-general">http://lists.sourceforge.net/mailman/listinfo/qmail-scanner-general</a> ,
or subscribe to the announcements-only list via <a href="http://lists.sourceforge.net/mailman/listinfo/qmail-scanner-announce">http://lists.sourceforge.net/mailman/listinfo/qmail-scanner-announce</a>. 
</p>
<p><font size="-3"><b>Last Updated:</b> <?php echo   date ("l dS of F Y h:i:s A",filemtime($SCRIPT_FILENAME)). " GMT"; ?></font>
<P>
</body>
</html>
